"use strict";

var _extends = require("babel-runtime/helpers/extends")["default"];

exports.__esModule = true;
exports.TaggedTemplateExpression = TaggedTemplateExpression;
exports.TemplateElement = TemplateElement;
exports.TemplateLiteral = TemplateLiteral;

function TaggedTemplateExpression(node) {
  this.print(node, "tag");
  this.print(node, "quasi");
}

function TemplateElement(node) {
  // this._push(node.value.raw);
  this.push({ type: "template", value: _extends({}, node.value, { code: this.code.slice(node.start, node.end) }) });
}

function TemplateLiteral(node) {
  this.push("`");

  // TODO
  if (this.format.preserve && node.tokenElements && node.tokenElements.length) {
    throw new Error("Not Implemented");
  } else {

    var quasis = node.quasis;

    for (var i = 0; i < quasis.length; i++) {
      this._simplePrint(quasis[i], node, {});

      if (i + 1 < quasis.length) {
        this.push("${");
        this._simplePrint(node.expressions[i], node, {});
        this.push("}");
      }
    }
  }

  this._push("`");
}